
// ServerSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ServerSample.h"
#include "ServerSampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CServerSampleDlg dialog




CServerSampleDlg::CServerSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CServerSampleDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bConnected = FALSE;
}

void CServerSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_CONSOLE, m_Edit_Console);
	DDX_Control(pDX, IDC_BUTTON_LISTEN, m_Button_Listen);
	DDX_Control(pDX, IDC_BUTTON_DISCONNECT, m_Button_Disconnect);
	DDX_Control(pDX, IDC_BUTTON_SEND, m_Button_Send);
	DDX_Control(pDX, IDC_EDIT_PORT, m_Edit_Port);
	DDX_Control(pDX, IDC_CHECK_CR, m_Check_CR);
	DDX_Control(pDX, IDC_CHECK_LF, m_Check_LF);
	DDX_Control(pDX, IDC_EDIT_SEND, m_Edit_Send);
}

BEGIN_MESSAGE_MAP(CServerSampleDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_LISTEN, &CServerSampleDlg::OnBnClickedButtonListen)
	ON_BN_CLICKED(IDC_BUTTON_DISCONNECT, &CServerSampleDlg::OnBnClickedButtonDisconnect)
	ON_BN_CLICKED(IDC_BUTTON_SEND, &CServerSampleDlg::OnBnClickedButtonSend)
END_MESSAGE_MAP()


// CServerSampleDlg message handlers

BOOL CServerSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_Edit_Port.SetLimitText(5);
	SetDlgItemInt(IDC_EDIT_PORT, 1470);

	m_Button_Disconnect.EnableWindow(FALSE);	
	m_Button_Send.EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CServerSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CServerSampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CServerSampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CServerSampleDlg::Accept(CEzSocket *Socket, int nErrorCode)
{
	SOCKADDR_IN saddr;
	CString strMsg;

	if(nErrorCode || !m_ListenSocket.Accept(m_ClientSocket, (SOCKADDR *)&saddr))
	{
		strMsg.Format(_T("Accept fail.\r\n"));
		m_Edit_Console.ReplaceSel(strMsg);
		return;
	}
	else
	{
		CString strIP;
		UINT nPort;

		m_ClientSocket.GetPeerName(strIP, nPort);

		strMsg.Format(_T("Accept new connection. IP : %s, Port : %d \r\n"), strIP, nPort);
		
		m_Edit_Console.ReplaceSel(strMsg);
		m_bConnected = TRUE;
	}

	Socket->Close();
	
	ChangeState(BUTTON_STATE_CONNECTED);
}


void CServerSampleDlg::ChangeState(int state)
{
	switch(state)
	{
		case BUTTON_STATE_INITIAL:
			m_Button_Listen.EnableWindow(TRUE);
			m_Button_Disconnect.SetWindowText(_T("DISCONNECT"));
			m_Button_Disconnect.EnableWindow(FALSE);
			m_Button_Send.EnableWindow(FALSE);
			break;
		case BUTTON_STATE_ACCEPT:
			m_Button_Listen.EnableWindow(FALSE);
			m_Button_Disconnect.SetWindowText(_T("STOP"));
			m_Button_Disconnect.EnableWindow(TRUE);
			m_Button_Send.EnableWindow(FALSE);
			break;
		case BUTTON_STATE_CONNECTED:
			m_Button_Listen.EnableWindow(FALSE);
			m_Button_Disconnect.SetWindowText(_T("DISCONNECT"));
			m_Button_Disconnect.EnableWindow(TRUE);
			m_Button_Send.EnableWindow(TRUE);
			break;
	}
}

void CServerSampleDlg::SocketClose(CEzSocket *Socket, int nErrorCode)
{
	Socket->Close();

	m_Edit_Console.ReplaceSel("Connection closed.\r\n");

	ChangeState(BUTTON_STATE_INITIAL);
}

void CServerSampleDlg::Receive(CEzSocket *Socket, int nErrorCode)
{
	int nLen, nCount;
	CString strMsg;
	BYTE buf[1024];

	memset(&buf, 0x00, sizeof(buf));

	if(nErrorCode)
	{
	}
	else
	{
		nLen = Socket->Receive(buf, 1024, 0);

		for(nCount = 0; nCount < nLen; nCount++)
		{
			strMsg.Format(_T("%c"), buf[nCount]);
			m_Edit_Console.ReplaceSel(strMsg);
		}		
	}
}
void CServerSampleDlg::OnBnClickedButtonListen()
{
	// TODO: Add your control notification handler code here
	CString strMsg;

	m_ListenSocket.Create(GetDlgItemInt(IDC_EDIT_PORT));

	if(!m_ListenSocket.Listen(1))
	{		
		strMsg.Format("Listen fail : error code %d\r\n", GetLastError());

		m_Edit_Console.ReplaceSel(strMsg);
		m_ListenSocket.Close();
		
		return;
	}

	ChangeState(BUTTON_STATE_ACCEPT);

	strMsg.Format("Listening on tcp port %u....\r\n", GetDlgItemInt(IDC_EDIT_PORT));

	m_Edit_Console.ReplaceSel(strMsg);
}

void CServerSampleDlg::OnBnClickedButtonDisconnect()
{
	// TODO: Add your control notification handler code here
	if(m_bConnected)
	{
		m_ClientSocket.Close();
		m_Edit_Console.ReplaceSel("Close connection.\r\n");
	}
	else
	{
		m_Edit_Console.ReplaceSel("Accept stopped.\r\n");
	}

	m_ListenSocket.Close();

	ChangeState(BUTTON_STATE_INITIAL);
}

void CServerSampleDlg::OnBnClickedButtonSend()
{
	// TODO: Add your control notification handler code here
	char buf[128];
	memset(&buf, 0x00, sizeof(buf));

	CString strMsg;
	m_Edit_Send.GetWindowText(strMsg);

	m_ClientSocket.Send(strMsg, strMsg.GetLength(), 0);

	if(m_Check_CR.GetCheck())
	{
		buf[0] = 0x0d;
		m_ClientSocket.Send(buf, 1 ,0);
	}
	if(m_Check_LF.GetCheck())
	{
		buf[0] = 0x0a;
		m_ClientSocket.Send(buf, 1 ,0);
	}
}
